//
//  ViewController.m
//  BTPay200
//
//  Created by zhong howard on 13-3-18.
//  Copyright (c) 2013年 __MyCompanyName__. All rights reserved.
//

#import "ViewController.h"


@interface ViewController ()

@end

@implementation ViewController
@synthesize resultsTextView;
@synthesize dataTextView;
@synthesize connectedLabel;
@synthesize txtAPDUData;
@synthesize txtDirectIO;
@synthesize theTitle;

@synthesize sView;
@synthesize view1;
@synthesize view2;
@synthesize view3;
@synthesize view4;
@synthesize view5;
@synthesize view6;
@synthesize pcControlPanes;


extern int g_IOS_Type;

-(void) appendMessageToResults:(NSString*) message{
    [self.resultsTextView setText:[NSString stringWithFormat:@"%@\n%@", self.resultsTextView.text, message]];
    [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
}

-(void) appendMessageToData:(NSString*) message{
    [self.dataTextView setText:[NSString stringWithFormat:@"%@\n%@", self.dataTextView.text, message]];
    [self.dataTextView scrollRangeToVisible:NSMakeRange([self.dataTextView.text length], 0)];
}

- (IBAction) DoClearLog:(id)sender{
    [self.resultsTextView setText: @""];
    [self.resultsTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];
    [self.dataTextView setText: @""];
    [self.dataTextView scrollRangeToVisible:NSMakeRange([self.resultsTextView.text length], 0)];

}



//for return IDTResult type function
-(void) displayUpRet2:(NSString*) operation returnValue: (RETURN_CODE)rt
{
    
    
    NSString * str = [NSString stringWithFormat:
                      @"%@ ERROR: ID-\"%i\", message: %@.",
                      operation, rt, [[IDT_BTPay sharedController] device_getResponseCodeString:rt]];
    [self appendMessageToResults:str];
    
}

- (IBAction) DoKeyboardOff:(id)sender{
    [sender resignFirstResponder];
}

#pragma mark - BTPay Delegate methods

- (void) dataInOutMonitor:(NSData*)data  incoming:(BOOL)isIncoming{
    [self appendMessageToData:[NSString stringWithFormat:@"%@: %@",isIncoming?@"IN":@"OUT",data.description]];
}




-(void)deviceConnected{
    NSLog(@"Connected --");
    connectedLabel.text = @"Connected";
    [self appendMessageToResults:@"([BTPay sharedController] Connected)"];
}

-(void)deviceDisconnected{
    NSLog(@"DisConnt --");
    connectedLabel.text = @"Disconnect";
    [self appendMessageToResults:@"([BTPay sharedController] Disconnect)"];
}

- (void) swipeMSRData:(IDTMSRData*)cardData{
    NSLog(@"--MSR event Received, Type: %d, data: %@", cardData.event, cardData.encTrack1);
    switch (cardData.event) {
        case EVENT_BTPAY_CARD_DATA:
        {
            switch (cardData.captureEncodeType) {
                case CAPTURE_ENCODE_TYPE_ISOABA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"ISO/ABA"]];
                    break;
                case CAPTURE_ENCODE_TYPE_AAMVA:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"AA/MVA"]];
                    break;

                case CAPTURE_ENCODE_TYPE_Other:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"Other"]];
                    break;

                case CAPTURE_ENCODE_TYPE_Raw:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"Raw"]];
                    break;

                default:
                    [self appendMessageToResults:[NSString stringWithFormat:@"Encryption Type: %@", @"UNKNOWN"]];

                    break;
            }
            
            [self appendMessageToResults:[NSString stringWithFormat:@"Full card data: %@", cardData.cardData]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 1: %@", cardData.track1]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 2: %@", cardData.track2]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Track 3: %@", cardData.track3]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 1: %i", cardData.track1Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 2: %i", cardData.track2Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Length Track 3: %i", cardData.track3Length]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 1: %@", cardData.encTrack1.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 2: %@", cardData.encTrack2.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Encoded Track 3: %@", cardData.encTrack3.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 1: %@", cardData.hashTrack1.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 2: %@", cardData.hashTrack2.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"Hash Track 3: %@", cardData.hashTrack3.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"KSN: %@", cardData.KSN.description]];
            NSLog(@"Track 1: %@", cardData.track1);
            NSLog(@"Track 2: %@", cardData.track2);
            NSLog(@"Track 3: %@", cardData.track3);
            NSLog(@"Encoded Track 1: %@", cardData.encTrack1.description);
            NSLog(@"Encoded Track 2: %@", cardData.encTrack2.description);
            NSLog(@"Encoded Track 3: %@", cardData.encTrack3.description);
            NSLog(@"Hash Track 1: %@", cardData.hashTrack1.description);
            NSLog(@"Hash Track 2: %@", cardData.hashTrack2.description);
            NSLog(@"Hash Track 3: %@", cardData.hashTrack3.description);
            NSLog(@"KSN: %@", cardData.KSN.description);

            return;
        }
            break;
            
        case EVENT_MSR_CANCEL_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Cancel Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_BACKSPACE_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Backspace Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_ENTER_KEY:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR Enter Key received: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        case EVENT_MSR_UNKNOWN:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) MSR unknown event, data: %@", cardData.encTrack1]];
            return;
        }
            break;
            
        default:
            break;
    }
}
- (void) commandResponse:(RETURN_CODE)code respData:(NSData *)response{
    [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Command Response code: %i", code]];
    [self appendMessageToResults:[NSString stringWithFormat:@"(Event)  Command Response data  received: %@\n%@", response.description,[[NSString alloc]initWithData:response encoding:NSASCIIStringEncoding]]];

}

static bool getencrypteddata;

- (void) pinpadData:(NSData*)value keySN:(NSData*)KSN event:(EVENT_PINPAD_Types)event{
    NSLog(@"--PIN event Received, Type: %d, data: %@,  ksn: %@", event, value.description,KSN.description);
    switch (event) {
        case EVENT_PINPAD_UNKNOWN:
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) PINPad unknown event, data: %@", value.description]];
            break;
            
        case EVENT_PINPAD_ENCRYPTED_PIN:
            if (value.length > 0) {
                [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Encrypted PIN data  received: %@", value.description]];

            }
            if (KSN.length > 0) {
                [self appendMessageToResults:[NSString stringWithFormat:@"(Event)  KSN data  received: %@", KSN.description]];

            }
            break;
        case EVENT_PINPAD_FUNCTION_KEY:
            if ([value.description isEqualToString:@"<43>"]) [self appendMessageToResults:@"CANCEL KEY PRESSED"];
            if ([value.description isEqualToString:@"<42>"]) [self appendMessageToResults:@"BACKSPACE KEY PRESSED"];
            if ([value.description isEqualToString:@"<45>"]) [self appendMessageToResults:@"ENTER KEY PRESSED"];
            if ([value.description isEqualToString:@"<23>"]) [self appendMessageToResults:@"# KEY PRESSED"];
            if ([value.description isEqualToString:@"<2a>"]) [self appendMessageToResults:@"* KEY PRESSED"];
    
            break;

        case EVENT_PINPAD_NUMERIC:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Numeric data  received: %@", [[NSString alloc] initWithData:value encoding:NSASCIIStringEncoding]]];
            /*
             aString = [[NSString alloc] initWithData: someData  encoding:NSUTF8StringEncoding];
             [self appendMessageToResults: [NSString stringWithFormat:@"Numeric is : %@", aString]];
             [aString release];
             */
        }
            break;
        case EVENT_PINPAD_AMOUNT:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Amount data  received: %.2f", [[[NSString alloc] initWithData:value encoding:NSASCIIStringEncoding] floatValue]/100]];
            /*
             aString = [[NSString alloc] initWithData: someData encoding:NSUTF8StringEncoding];
             [self appendMessageToResults: [NSString stringWithFormat:@"Amount is : %@", aString]];
             [aString release];
             */
        }
            break;
            
        case EVENT_PINPAD_ACCOUNT:
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Encrypted Account data  received: %@", value.description]];
            [self appendMessageToResults:[NSString stringWithFormat:@"(Event) KSN data  received: %@", KSN.description]];
            /*
             aString = [[NSString alloc] initWithData: someData encoding:NSUTF8StringEncoding];
             [self appendMessageToResults: [NSString stringWithFormat:@"Account is : %@", aString]];
             [aString release];
             */
        }
            break;
            
        case EVENT_PINPAD_ENCRYPTED_DATA:
        {
            if(getencrypteddata)
            {
                [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Encrypted data  received: %@", value.description]];
                [self appendMessageToResults:[NSString stringWithFormat:@"(Event) Encrypted data  KSN: %@", KSN.description]];
                getencrypteddata = false;
            }
        }
            break;
            
        case EVENT_PINPAD_CANCEL:
        {
            [self appendMessageToResults: @"(Event) PINPad Canceled."];
        }
            break;
            
        case EVENT_PINPAD_TIMEOUT:
        {
            [self appendMessageToResults:@"(Event) PINPad Timeout."];
        }
            break;
        case EVENT_PINPAD_DATA_ERROR:
        {
            [self appendMessageToResults:@"(Event) PINPad Data Error."];
        }
            break;
            
        default:
            break;
    }
}



#pragma mark - View methods

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    
    //for iPhone
    if (0 == g_IOS_Type) {
        CGRect frame = self.sView.frame;
        frame.size.width = [UIScreen mainScreen].bounds.size.width;
        CGSize contentSize = frame.size;
        contentSize.width *= 6;
        self.sView.contentSize = contentSize;
        
        // add to scroll view
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 5;
        self.view6.frame = frame;
        [self.sView addSubview: self.view6];
        
        // add to scroll view
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 4;
        self.view5.frame = frame;
        [self.sView addSubview: self.view5];
        
        
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 3;
        self.view4.frame = frame;
        [self.sView addSubview: self.view4];

        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 2;
        self.view3.frame = frame;
        [self.sView addSubview: self.view3];

        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 1;
        self.view2.frame = frame;
        [self.sView addSubview: self.view2];
        
        frame.origin.y = 0;
        frame.origin.x = frame.size.width * 0;
        self.view1.frame = frame;
        [self.sView addSubview: self.view1];
        
        self.pcControlPanes.numberOfPages = 4;
        self.pcControlPanes.currentPage = 0;
    }

    NSString *version = [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"];
    NSString *framework = [IDT_BTPay SDK_version ];
    
    theTitle.text = [NSString stringWithFormat:@"BTPay Demo %@ / %@",version,framework];
    
    //init object
    [IDT_BTPay sharedController].delegate = self;
    [[IDT_BTPay sharedController] config_setCmdTimeOutDuration: 4];

}

- (void)viewDidUnload
{
    [[IDT_BTPay sharedController] close];
    

    [super viewDidUnload];
    // Release any retained subviews of the main view.
}

- (void)scrollViewDidScroll:(UIScrollView *)sender {
    if (sender != self.sView)
        return;
    
    //for iPhone
    if (0 == g_IOS_Type) {
        //update UIPageControl object
        CGFloat pageWidth = self.sView.frame.size.width;
        int page = floor((self.sView.contentOffset.x + pageWidth / 2) / pageWidth);
        self.pcControlPanes.currentPage = page;
    }
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    
    NSLog(@"--viewDidAppear");
   [[IDT_BTPay sharedController] isConnected];

}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    if ([[UIDevice currentDevice] userInterfaceIdiom] == UIUserInterfaceIdiomPhone) {
        return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
    } else {
        return YES;
    }
}


#pragma mark - spec methods
- (IBAction) f_getFirm:(id)sender
{    NSString *result;
    RETURN_CODE rt = [[IDT_BTPay sharedController]  device_getFirmwareVersion:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get FM info:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get FM info" returnValue: rt];
    }
}

- (IBAction) f_DoTest:(id)sender
{
}

- (IBAction) f_enterSleep:(id)sender
{
    RETURN_CODE rt = [[IDT_BTPay sharedController] lcd_enterSleepMode];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Enter Sleep Mode OK."];
    }
    else{
        [self displayUpRet2: @"Enter Sleep Mode" returnValue: rt];
    }
}

- (IBAction) f_getModelNumber:(id)sender
{
    NSString* result;
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_getModelNumber:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        
        [self appendMessageToResults: [NSString stringWithFormat:@"Get ModelNumber:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get ModelNumber" returnValue: rt];
    }
}

- (IBAction) f_getSerialNumber:(id)sender
{
    NSString* result;
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_getSerialNumber:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get Serial Number:  %@", result]];
    }
    else{
        [self displayUpRet2: @"Get Serial Number" returnValue: rt];
    }
}
- (IBAction) f_setSerialNumber:(id)sender
{
    
    
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_setSerialNumber:@"432T261773"];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Set Serial Number OK"]];
    }
    else{
        [self displayUpRet2: @"Get Serial Number" returnValue: rt];
    }
}








- (IBAction) f_getDateTime:(id)sender{
    NSString* result;
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_getDateTime:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:[NSString stringWithFormat:@"DateTime: %@",result]];
    }
    else{
        [self displayUpRet2: @"Get DataTime" returnValue: rt];
    }
}

- (IBAction) f_setDateTime:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_setDateTime:@"140312040506"];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"set DateTime: OK."];
    }
    else{
        [self displayUpRet2: @"set DateTime" returnValue: rt];
    }
    
}

- (IBAction) f_setBluetoothAddress:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_setBluetoothAddress:@"22223344ccdd"];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"set BluetoothAddress: OK."];
    }
    else{
        [self displayUpRet2: @"set BluetoothAddress" returnValue: rt];
    }
    
}


- (IBAction) f_BeeperControl:(id)sender{
    unsigned short beep[] = {0xb00,0x400,0x800,0x300};
    RETURN_CODE rt = [[IDT_BTPay sharedController] device_sendBeep:beep numberOfTones:2];
    if ( RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"BeeperControl: OK."];
    }
    else{
        [self displayUpRet2: @"BeeperControl" returnValue: rt];
    }
    
}

- (IBAction) f_RebootDevice:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] device_rebootDevice];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"RebootDevice: OK."];
    }
    else{
        [self displayUpRet2: @"RebootDevice" returnValue: rt];
    }
    
}

- (IBAction) f_DisableMSR:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] msr_cancelMSRSwipe];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"DisableMSR: OK."];
    }else
    {
        [self displayUpRet2: @"DisableMSR" returnValue:rt];
    }
}

- (IBAction) f_GetPinPadStatus:(id)sender{
    NSData* result;
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getPINpadStatus:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:[NSString stringWithFormat:@"PinPadStatus: %@.", result]];
        if ([result.description isEqualToString:@"<01>"]) [self appendMessageToResults:@"Pinpad is inactive"];
        if ([result.description isEqualToString:@"<02>"]) [self appendMessageToResults:@"Pinpad has been activated, public key not loaded"];
        if ([result.description isEqualToString:@"<03>"]) [self appendMessageToResults:@"Public key loaded, but firmware key, numeric key, and check value not loaded"];
        if ([result.description isEqualToString:@"<10>"]) [self appendMessageToResults:@"Pinpad is normal work status"];
        if ([result.description isEqualToString:@"<30>"]) [self appendMessageToResults:@"Pinpad suspended status if password input error"];
        if ([result.description isEqualToString:@"<31>"]) [self appendMessageToResults:@"Pinpad suspended status if get PIN(MKSK)120 times in one hour."];
    }
    else{
        [self displayUpRet2: @"GetPinPadStatus" returnValue: rt];
    }
    return;
}

- (IBAction) f_CancelPin:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_cancelPin];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"CancelPin: OK."];
    }else
    {
        [self displayUpRet2: @"CancelPin" returnValue:rt];
        //[self appendMessageToResults:@"CancelPin: Failed."];
    }
    return;
}

- (IBAction) f_DisplayMessage:(id)sender
{
    
    RETURN_CODE rt = [[IDT_BTPay sharedController] lcd_displayMessage:@"Line 1" line2:@"Line 2" line3:@"Line 3" line4:@"Line 4"];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"DisplayMessage: OK."];
    }else
    {
        [self displayUpRet2: @"DisplayMessage" returnValue: rt];
    }
    
}

- (IBAction) f_GetPinLength:(id)sender{
    NSData* result;
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getPinLength:&result];
    if(RETURN_CODE_DO_SUCCESS == rt){
        if (result.length>1) {
            Byte * dd = (unsigned char*)result.bytes;
            [self appendMessageToResults:[NSString stringWithFormat:@"GetPinLength: min=%d max=%d", dd[0], dd[1]]];
        }
        else
        {
            [self appendMessageToResults:[NSString stringWithFormat:@"GetPinLength fail, %@.", result.description]];
        }
    }else
    {
        [self displayUpRet2: @"GetPinLength" returnValue: rt];
    }
    
}

- (IBAction) f_SetPinLength:(id)sender
{
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_setPinLength:5 maxLength:10];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetPinLength: OK."];
    }else
    {
        [self displayUpRet2: @"SetPinLength" returnValue: rt];
    }
}

- (IBAction) f_GetMSR_Format:(id)sender{
    NSString* response;
    RETURN_CODE rt = [[IDT_BTPay sharedController] msr_getEncryptMSRFormat:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:[NSString stringWithFormat:@"GetMSR_dataFormat: %@", response]];
        if ([response isEqualToString:@"0"]) [self appendMessageToResults:@"Encrypted with Data Key"];
        if ([response isEqualToString:@"1"]) [self appendMessageToResults:@"Encrypted with PIN Key"];

    }else
    {
        [self displayUpRet2: @"GetMSR_dataFormat" returnValue: rt];
    }
    
}

- (IBAction) f_SetMSR_Format:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] msr_setEncryptMSRFormat:1];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetMSR_dataFormat: OK."];
    }else
    {
        [self displayUpRet2: @"SetMSR_dataFormat" returnValue: rt];
    }
}


- (IBAction) f_getLanguage:(id)sender{
    NSUInteger* response;
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_getLanguageType:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        int r = (int)response;
        [self appendMessageToResults:[NSString stringWithFormat:@"f_getLanguage: %i", r]];
        switch (r) {
            case LANGUAGE_TYPE_ENGLISH:
                [self appendMessageToResults:@"Language is English"];
                break;
            case LANGUAGE_TYPE_PORTUGUESE:
                [self appendMessageToResults:@"Language is Portuguese"];
                break;
            case LANGUAGE_TYPE_SPANISH:
                [self appendMessageToResults:@"Language is Spanish"];
                break;
                
            default:
                [self appendMessageToResults:@"Language is Unknown"];

                break;
        }
        
    }else
    {
        [self displayUpRet2: @"GetMSR_dataFormat" returnValue: rt];
    }
    
}

- (IBAction) f_setLanguage:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] config_setLanguageType:LANGUAGE_TYPE_ENGLISH];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"f_setLanguage: OK."];
    }else
    {
        [self displayUpRet2: @"f_setLanguage" returnValue: rt];
    }
}



- (IBAction) f_GetCardDataEncryption:(id)sender{
    NSString* response;
    RETURN_CODE rt = [[IDT_BTPay sharedController] msr_getCardDataEncryptedAlgorithm:&response];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:[NSString stringWithFormat:@"GetCardDataEncryption: %@", response]];
        if ([response isEqualToString:@"1"]) [self appendMessageToResults:@"Encrypted with 3DES"];
        if ([response isEqualToString:@"2"]) [self appendMessageToResults:@"Encrypted with AES"];
        
    }else
    {
        [self displayUpRet2: @"GetCardDataEncryption" returnValue: rt];
    }
    
}

- (IBAction) f_SetCardDataEncryption:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] msr_setCardDataEncryptedAlgorithm:2];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"SetCardDataEncryption: OK."];
    }else
    {
        [self displayUpRet2: @"SetCardDataEncryption" returnValue: rt];
    }
}


- (IBAction) f_EnableMSR_waitData: (id)sender{

    
    RETURN_CODE rt = [[IDT_BTPay sharedController] msr_startMSRSwipeWithDisplay:@"Please" line2:@"swipe card" line3:nil];
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"EnableMSR: OK."];
    }else
    {
        [self displayUpRet2: @"EnableMSR" returnValue:rt];
    }
}

- (IBAction) f_GetEncryptedPin: (id)sender
{
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getEncryptedPIN:@"1234567890123456" keyType:PIN_KEY_TDES_DUKPT_extp line1:@"Please" line2:@"input PIN" line3:nil];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Enter GetEncryptedPin mode: OK."];
    }else
    {
        [self displayUpRet2: @"Enter GetEncryptedPin mode" returnValue:rt];
    }
    
}

- (IBAction) f_getFunctionKey:(id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getFunctionKey];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Enter f_getFunctionKey mode: OK."];
    }else
    {
        [self displayUpRet2: @"Enter f_getFunctionKey mode" returnValue:rt];
    }
}

- (IBAction) f_GetNumeric: (id)sender{
    

    
   


    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getNumeric:false minLength:4 maxLength:12 messageID:42 language:LANGUAGE_TYPE_ENGLISH];  //42 = ENTER DRIVER ID

    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Enter Numeric mode: OK."];
    }else
    {
        [self displayUpRet2: @"Enter Numeric mode" returnValue:rt];
    }
}

- (IBAction) f_GetAmount: (id)sender{

    
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getAmount:1 maxLength:12 messageID:5 language:LANGUAGE_TYPE_ENGLISH];  //5 = PLEASE ENTER

    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Enter Amount mode: OK."];
    }else
    {
        [self displayUpRet2: @"Enter Amount mode" returnValue:rt];
    }
    
}

- (IBAction) f_GetIccReaderStatus: (id)sender
{
    ICCReaderStatus* response;
    RETURN_CODE rt = [[IDT_BTPay sharedController] icc_getICCReaderStatus:&response];
    if(RETURN_CODE_DO_SUCCESS != rt){
        [self displayUpRet2: @"GetICCReaderStatus" returnValue: rt];
        return;
    }
    
        NSString *sta;
        if(response->iccPower)
            sta =@"[ICC Powered]";
        else
            sta = @"[ICC Power not Ready]";
        if(response->cardSeated)
            sta =[NSString stringWithFormat:@"%@,[Card Seated]", sta];
        else
            sta =[NSString stringWithFormat:@"%@,[Card not Seated]", sta];
        
        [self appendMessageToResults:[NSString stringWithFormat:@"%@",sta]];
    


}

- (IBAction) f_IccPowerON: (id)sender{
    NSData* response;
    RETURN_CODE rt = [[IDT_BTPay sharedController] icc_powerOnICC:&response];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:[NSString stringWithFormat:@"ICC Powerd On, data: %@\n%@", response.description, [[NSString alloc] initWithData:response encoding:NSASCIIStringEncoding] ]];
        int lengthp = response.length;
        Byte * Response = (Byte*)[response bytes];
        if (0x90 == Response[lengthp-2])
        {
            [self appendMessageToResults:@" - Success."];
        }
        else
        {
            [self appendMessageToResults:@" - Failed."];
        }
    }else
    {
        [self displayUpRet2: @"ICC Powerd On" returnValue:rt];
    }
    
    return;
}

- (IBAction) f_UploadJpeg: (id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] device_uploadJPEG:[NSData dataWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"IDTechLogo" ofType:@"jpg"]]];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Upload JPEG: OK."];
    }else
    {
        [self displayUpRet2: @"Upload JPEG" returnValue:rt];
    }
    
    return;
    
}
- (IBAction) f_ShowJpeg: (id)sender{
    RETURN_CODE rt = [[IDT_BTPay sharedController] lcd_showJPEG:0 Y0:20 X1:126 Y1:42];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Show JPEG: OK."];
    }else
    {
        [self displayUpRet2: @"Show JPEG" returnValue:rt];
    }
    
    return;
    
}

- (IBAction) f_IccPowerOFF: (id)sender{

    NSString* error;
    RETURN_CODE rt = [[IDT_BTPay sharedController] icc_powerOffICC:&error];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"ICC PowerOff: OK."];
    }else
    {
        [self displayUpRet2: @"ICC PowerOff" returnValue:rt];
    }
}

-(BOOL) isValidChar:(Byte)byChar{
    if ( ((byChar>(Byte)0x2F) && (byChar<(Byte)0x3A)) //'0' - '9'
        || ((byChar>(Byte)0x40) && (byChar<(Byte)0x47)) //'A' - 'F'
        || ((byChar>(Byte)0x60) && (byChar<(Byte)0x67)) //'a' - 'f'
        )
    {
        return YES;
    }
    return NO;
}


-(NSData*) hexStringToBytes:(NSString*)hexString{
    if (hexString.length<1) {
        return nil;
    }
    
    char tmpCh[1024] = {0};
    int count = 0;
    for (int k=0; k<hexString.length;k++) {
        char c = [hexString characterAtIndex:k];
        if (c == (char)0x20) {
            continue;
        }
        tmpCh[count] = c;
        count++;
    }
    tmpCh[count] = 0;
    
    if (count % 2) {
        return nil;
    }
    
    NSString *temp = [[NSString alloc] initWithUTF8String:tmpCh];
    int m = temp.length % 2;
    if (m>0) {
        return nil;
    }
    
    NSMutableData *result = [[NSMutableData alloc] init];
    unsigned char byte;
    char hexChars[3] = {0};
    for (int i=0; i < (temp.length/2); i++) {
        hexChars[0] = [temp characterAtIndex:i*2];
        hexChars[1] = [temp characterAtIndex:i*2+1];
        
        if (![self isValidChar:hexChars[0]] || ![self isValidChar:hexChars[1]]) {
            return nil;
        }
        byte = strtol(hexChars, NULL, 16);
        [result appendBytes:&byte length:1];
    }
    return [NSData dataWithData:result];
}

- (IBAction) f_DirectIO:(id)sender
{
    [txtDirectIO resignFirstResponder];
    
    NSData *dataBuffer = nil;
    NSString *valueEntered = txtDirectIO.text;
    if (valueEntered.length < 2)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                        message:@"input data is invalid."
                                                       delegate:nil
                                              cancelButtonTitle:@"Dismiss"
                                              otherButtonTitles:nil];
        [alert show];
        return;
    }
    else
    {
        dataBuffer = [self hexStringToBytes:valueEntered];
        if (dataBuffer.length<1) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                            message:@"input value is invalid."
                                                           delegate:nil
                                                  cancelButtonTitle:@"Dismiss"
                                                  otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    NSData* response;
    RETURN_CODE rt = [[IDT_BTPay sharedController] device_sendDataCommand:dataBuffer calcLRC:true response:&response];
    if (RETURN_CODE_DO_SUCCESS == rt) {
        [self appendMessageToResults:[NSString stringWithFormat:@"DirectIO Result: %@", response.description]];
        if (3 == response.length) {
            Byte *by1 = (unsigned char*)response.bytes;
            if ( (Byte)0x15 == by1[0]) {
                //RETURN_CODE rt2;
                NSData *nd = [NSData dataWithBytes: &by1[1] length:2];
                NSString *str = [[IDT_BTPay sharedController] device_getResponseCodeString:(((int)&by1[1]*256)+(int)&by1[2])];
                [self appendMessageToResults:[NSString stringWithFormat:@", errCode: %@, errInfo: %@", nd.description, str]];
            }
        }
    }
    else
    {
        [self displayUpRet2: @"DirectIO" returnValue:rt];
    }
}

- (IBAction) f_getLastKSN:(id)sender{
    NSData* result;
    RETURN_CODE rt = [[IDT_BTPay sharedController] icc_getAPDU_KSN:&result];
    if (RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults: [NSString stringWithFormat:@"Get KSN:  %@", result.description]];
        txtKSNData.text = [[[result.description stringByReplacingOccurrencesOfString:@">" withString:@""] stringByReplacingOccurrencesOfString:@"<" withString:@""] stringByReplacingOccurrencesOfString:@" " withString:@""];
    }
    else{
        [self displayUpRet2: @"Get KSN" returnValue: rt];
    }
}

- (IBAction) f_IccExchangeAPDU: (id)sender{
    [txtAPDUData resignFirstResponder];
    
    NSData *dataBuffer = nil;
    NSString *valueEntered = txtAPDUData.text;
    if (valueEntered.length < 6)
    {
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                        message:@"input APDU data is invalid."
                                                       delegate:nil
                                              cancelButtonTitle:@"Dismiss"
                                              otherButtonTitles:nil];
        [alert show];
        return;
    }
    else
    {
        dataBuffer = [self hexStringToBytes:valueEntered];
        if (dataBuffer.length<3) {
            UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Invalid"
                                                            message:@"input value is invalid."
                                                           delegate:nil
                                                  cancelButtonTitle:@"Dismiss"
                                                  otherButtonTitles:nil];
            [alert show];
            return;
        }
    }
    APDUResponse* response;
    RETURN_CODE rt;
    if (encryptedSwitch.on) {
        rt = [[IDT_BTPay sharedController] icc_exchangeEncryptedAPDU:dataBuffer ksn:[self hexToData:txtKSNData.text] response:&response];
    }
    else{
        rt = [[IDT_BTPay sharedController] icc_exchangeAPDU:dataBuffer response:&response];
    }
 

    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: Encrypted %@", response.hasEncryption?@"TRUE":@"FALSE" ]];
        [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: APDU %@", response.response.description ]];
        [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: Has KSN %@", response.hasKSN?@"TRUE":@"FALSE" ]];
        [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: KSN %@", response.ksn.description ]];
        [self appendMessageToResults:[NSString stringWithFormat:@"ExchangeAPDU Result: SW1=%2x SW2=%2x", response.SW1,response.SW2 ]];
    }else
    {
        [self displayUpRet2: @"ExchangeAPDU" returnValue:rt];
    }
    

    
    


}

- (IBAction) f_SetIdleTimeForSleep: (id)sender
{
    int nSecond = 30;    
    RETURN_CODE rt = [[IDT_BTPay sharedController] lcd_setIdleTimeForSleep: nSecond];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"SetIdleTimeForSleep 30: OK."];
    }else
    {
        [self displayUpRet2: @"SetIdleTimeForSleep" returnValue:rt];
    }
    
}

- (IBAction) f_GetAccount: (id)sender
{
    

    
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getCardAccount:12 max:20 line1:@"Please" line2:@"Input Account"];
    
    if(RETURN_CODE_DO_SUCCESS == rt){
        [self appendMessageToResults:@"Enter GetAccount mode: OK."];
    }else
    {
        [self displayUpRet2: @"Enter GetAccount mode" returnValue:rt];
    }
    
}

#pragma mark ActionSheet
typedef enum {
    ACTION_SHEET_MSR_Encrypt_Mode=501,
    ACTION_SHEET_PIN_EncryptedData,
    ACTION_SHEET_ICC_KeyType_DUKPT,
} ActionSheetList;

-(void)actionSheet:(UIActionSheet *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (buttonIndex == actionSheet.cancelButtonIndex) {
        return;
    }
    
    int normalizedButtonIdx = buttonIndex - actionSheet.firstOtherButtonIndex;
    
    [actionSheet dismissWithClickedButtonIndex:actionSheet.cancelButtonIndex animated:YES];
    
    switch (actionSheet.tag) {
        case ACTION_SHEET_PIN_EncryptedData:
        {
            BOOL bP = NO;
            switch (normalizedButtonIdx) {
                case 0: //not last package
                {
                    bP = NO;
                    getencrypteddata = false;
                    break;
                }
                case 1: //is last package
                {
                    bP = YES;
                    getencrypteddata =true;
                    break;
                }
            }
            [self Do_GetEncryptedData: bP];
        }
            break;
    }
}


-(BOOL) Do_GetEncryptedData: (BOOL) bFlag
{

    

    Byte btTp = 0x00;
    if (bFlag) {
        btTp = 0x01;
    }
    RETURN_CODE rt = [[IDT_BTPay sharedController] pin_getEncryptedData:bFlag?0x01:0x00 minLength:1 maxLength:16 messageID:5 language:LANGUAGE_TYPE_ENGLISH];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"Enter EncryptedData mode: OK."];
    }else
    {
        [self displayUpRet2: @"Enter EncryptedData mode" returnValue:rt];
    }
    return NO;
}

- (IBAction) f_GetEncryptedData: (id)sender
{
    UIActionSheet *actionSheet = [[UIActionSheet alloc] initWithTitle:@"Select Type"
                                                             delegate:self
                                                    cancelButtonTitle:@"Cancel"
                                               destructiveButtonTitle:nil
                                                    otherButtonTitles:
                                  @"Not last package",
                                  @"Is last package",
                                  nil];
    actionSheet.actionSheetStyle = UIActionSheetStyleBlackTranslucent;
    actionSheet.tag = (int)ACTION_SHEET_PIN_EncryptedData;
    [actionSheet showInView:self.view];
    return;
}

-(IBAction) getTerminalFile:(id)sender{
    TerminalData *t;
   int rt= [[IDT_BTPay sharedController] emv_retrieveTerminalData:&t];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getTerminalFile: OK."];
    }else
    {
        [self displayUpRet2: @"getTerminalFile" returnValue:rt];
        return;
    }
    if (t == nil) {
        [self appendMessageToResults:@"Terminal File Not Returned - Try Again"];
    }
    NSData *term = [NSData dataWithBytes:&t[0] length:44];
    NSLog(@"Term Data = %@",term.description);
    [self appendMessageToResults:[NSString stringWithFormat:@"Term Data = %@", term.description]];
    
}
-(IBAction) removeTerminalFile:(id)sender{
    int rt=[[IDT_BTPay sharedController] emv_removeTerminalData];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"removeTerminalFile: OK."];
    }else
    {
        [self displayUpRet2: @"removeTerminalFile" returnValue:rt];
    }
}

-(IBAction)createTerminalFile:(id)sender{
    
    //btpay
    TerminalData t;
    t.terminalCountryCode[0] = 0x08;
    t.terminalCountryCode[1] = 0x40;
    t.provideCardholderConfirmation = 0x01;
    t.terminalType = 0x22;  //21 online only, 22 offline with online, 23 ofline only
    t.emvContact = 0x01;
    t.terminalCapabilities[0] = 0xE0; //8=Manual Key Entry, 7=Magnetic Strip, 6=IC with contacts
    t.terminalCapabilities[1] = 0x20;  //8=Plainext Pin, 7=Enciphered Pin for Online, 6 = Signature, 5 = Enciphered Pin Offline, 4= No CVM
    t.terminalCapabilities[2] = 0xE8;  //8=SDA, 7=DDA, 6=Card Capture, 5=RFU, 4=CDA
    t.additionalTerminalCapabilities[0] = 0x40;  //8=cash, 7=goods, 6=services, 5=cashback, 4=inquiry, 3=transfer, 2=payment, 1=admin
    t.additionalTerminalCapabilities[1] = 0x00;  //8=cash deposit
    t.additionalTerminalCapabilities[2] = 0x80;  //8=numeric keys, 7=alpha-special keys, 6=command keys, 5=function keys
    t.additionalTerminalCapabilities[3] = 0x10;  //8=Print attend, 7=Print, cardholder, 6=display atten, 5=display cardholder, 4/3=RUF, 2=code10, 1=code9
    t.additionalTerminalCapabilities[4] = 0x01;  //8=code8.... 1=code1
    t.emvContactless = 0x00;
    t.magstripe = 0x01;
    t.pinTimeOut = 0x20;
    t.batchManaged = 0x00;
    t.adviceManaged = 0x00;
    t.pse = 0x00;
    t.autoRun = 0x00;
    t.predefinedAmount[0]= 0x00;
    t.predefinedAmount[1]= 0x00;
    t.predefinedAmount[2]= 0x00;
    t.pinByPass = 0x00;
    t.referalManaged = 0x01;
    t.defaultTAC = 0x01;
    t.defaultTACDefault[0] = 0x00;
    t.defaultTACDefault[1] = 0x00;
    t.defaultTACDefault[2] = 0x80;
    t.defaultTACDefault[3] = 0x00;
    t.defaultTACDefault[4] = 0x00;
    t.defaultTACDenial[0] = 0x00;
    t.defaultTACDenial[1] = 0x00;
    t.defaultTACDenial[2] = 0x00;
    t.defaultTACDenial[3] = 0x00;
    t.defaultTACDenial[4] = 0x00;
    t.defaultTACOnline[0] = 0x00;
    t.defaultTACOnline[1] = 0x00;
    t.defaultTACOnline[2] = 0x00;
    t.defaultTACOnline[3] = 0x00;
    t.defaultTACOnline[4] = 0x00;
    t.notRTS = 0x00;
    t.notVelocity = 0x00;
    t.cdaType = 0x02;
    
    int rt=[[IDT_BTPay sharedController] emv_setTerminalData:t];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"createTerminalFile: OK."];
    }else
    {
        [self displayUpRet2: @"createTerminalFile" returnValue:rt];
    }
}

-(IBAction) createAIDFile:(id)sender{
    ApplicationID a;
    
    for (int x = 0; x < 252; x++) {
        a.tdolValue[x] = 0x00;
        a.ddolValue[x] = 0x00;
        if (x < 5) {
            a.tACDefault[x] = 0x00;
            a.tACDenial[x] = 0x00;
            a.tACOnline[x] = 0x00;
        }
        
    }
    
    
    
    a.acquirerIdentifier[0] = 0x00;
    a.acquirerIdentifier[1] = 0x00;
    a.acquirerIdentifier[2] = 0x00;
    a.acquirerIdentifier[3] = 0x00;
    a.acquirerIdentifier[4] = 0x00;
    a.acquirerIdentifier[5] = 0x00;
    a.aid[0] = 0xa0;
    a.aid[1] = 0x00;
    a.aid[2] = 0x00;
    a.aid[3] = 0x00;
    a.aid[4] = 0x25;
    a.aid[5] = 0x01;
    a.aid[6] = 0x08;
    a.aid[7] = 0x02;
    a.aid[8] = 0x00;
    a.aid[9] = 0x00;
    a.aid[10] = 0x00;
    a.aid[11] = 0x00;
    a.aid[12] = 0x00;
    a.aid[13] = 0x00;
    a.aid[14] = 0x00;
    a.aid[15] = 0x00;
    a.aidLen = 0x08;
    a.applicationSelectionIndicator = 0x01;
    a.applicationVersionNumber[0] = 0x00;
    a.applicationVersionNumber[1] = 0x01;
    a.XAmount[0]=0x00;
    a.XAmount[1]= 0x00;
    a.XAmount[2] = 0x00;
    a.YAmount[0] = 0x00;
    a.YAmount[1] = 0x00;
    a.YAmount[2] = 0x00;
    a.skipTACIACDefault=0x01;
    a.tac = 0x01;
    a.floorlLimitChecking = 0x01;
    a.randomTransactionSelection = 0x01;
    a.velocitiyChecking=0x01;
    //tacdenial[5]
    //taconline[5]
    //tacdefault[5]
    a.terminalFloorLimit[0] = 0x00;
    a.terminalFloorLimit[1] = 0x3A;
    a.terminalFloorLimit[2] = 0x98;
    a.targetPercentage = 0x32;
    a.thresholdValue[0] = 0x00;
    a.thresholdValue[1] = 0x27;
    a.thresholdValue[2] = 0x10;
    a.maxTargetPercentage = 0x32;
    a.defaultTDOL = 0x01;
    a.tdolValue[0] = 0x9F;
    a.tdolValue[1] = 0x08;
    a.tdolValue[2] = 0x02;
    a.tdolLen = 0x03;
    a.defaultDDOL=0x01;
    a.ddolValue[0] = 0x9F;
    a.ddolValue[1] = 0x02;
    a.ddolValue[2] = 0x06;
    a.ddolLen = 0x03;
    a.transactionCurrencyCode[0]=0x08;
    a.transactionCurrencyCode[1]=0x40;
    a.transactionCurrencyExponent = 0x02;
    
    int rt=[[IDT_BTPay sharedController] emv_setApplicationData:a];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"createAIDFile: OK."];
    }else
    {
        [self displayUpRet2: @"createAIDFile" returnValue:rt];
    }
}
-(IBAction) getAIDFile:(id)sender{
    ApplicationID *t;
    int rt = [[IDT_BTPay sharedController] emv_retrieveApplicationData:@"a000000025010802" response:&t];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getAIDFile: OK."];
    }else
    {
        [self displayUpRet2: @"getAIDFile" returnValue:rt];
        return;
    }
    if (t == nil) {
        [self appendMessageToResults:@"AID File Not Returned - Try Again"];
    }
    NSData *term = [NSData dataWithBytes:&t[0] length:44];
    NSLog(@"AID Data = %@",term.description);
    [self appendMessageToResults:[NSString stringWithFormat:@"AID Data = %@", term.description]];
    
}
-(IBAction) removeAIDFile:(id)sender{
    int rt=[[IDT_BTPay sharedController] emv_removeApplicationData:@"a000000025010802"];
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"removeAIDFile: OK."];
    }else
    {
        [self displayUpRet2: @"removeAIDFile" returnValue:rt];
    }
    
}
-(IBAction) getAIDFList:(id)sender{
    NSArray *dict;
    int rt=[[IDT_BTPay sharedController] emv_retrieveAIDList:&dict];
    if (dict == nil) {
        [self appendMessageToResults:@"AID List Not Returned - Try Again"];
    }
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getAIDFList: OK."];
    }else
    {
        [self displayUpRet2: @"getAIDFList" returnValue:rt];
        return;
    }
    NSLog(@"array = %@",dict.description);
    [self appendMessageToResults:[NSString stringWithFormat:@"array = %@", dict.description]];
}


-(IBAction) createCAPKFile:(id)sender{
    CAKey a;
    a.rid[0] = 0xa0;
    a.rid[1] = 0x00;
    a.rid[2] = 0x00;
    a.rid[3] = 0x00;
    a.rid[4] = 0x03;
    a.index = 0x01;
    a.exponentLength = 0x01;
    
    a.exponent[0] = 0x03;
    a.exponent[1] = 0x00;
    a.exponent[2] = 0x00;
    NSData*d = [self hexToData:@"C696034213D7D8546984579D1D0F0EA519CFF8DEFFC429354CF3A871A6F7183F1228DA5C7470C055387100CB935A712C4E2864DF5D64BA93FE7E63E71F25B1E5F5298575EBE1C63AA617706917911DC2A75AC28B251C7EF40F2365912490B939BCA2124A30A28F54402C34AECA331AB67E1E79B285DD5771B5D9FF79EA630B75"];
    a.keyLength = d.length;
    Byte *keyByte = (Byte *)d.bytes;
    for (int x = 0; x < 248; x++) {
        if (x < a.keyLength) {
            a.key[x] = keyByte[x];
        }
        else{
            a.key[x] = 0;
        }
    }
    
    int rt = [[IDT_BTPay sharedController] emv_setCAPK:a];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"createCAPKFile: OK."];
    }else
    {
        [self displayUpRet2: @"createCAPKFile" returnValue:rt];
    }
    
    
    
}
-(IBAction) getCAPKFile:(id)sender{
    CAKey* key;
    int rt=[[IDT_BTPay sharedController] emv_retrieveCAPK:@"a000000003" index:@"01" response:&key];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getCAPKFile: OK."];
    }else
    {
        [self displayUpRet2: @"getCAPKFile" returnValue:rt];
        return;
    }
    if (key == nil) {
        [self appendMessageToResults:@"CAPK File Not Returned - Try Again"];
        return;
    }
    NSData *d3 = [NSData dataWithBytes:key->rid length:5];
    NSData *d2 = [NSData dataWithBytes:key->exponent length:key->exponentLength];
    NSData *d1 = [NSData dataWithBytes:key->key length:key->keyLength];
    NSLog(@"2key = %@",[d1 description]);
    NSLog(@"2index = %x",key->index);
    NSLog(@"2exponent = %@",[d2 description]);
    NSLog(@"2rid = %@",[d3 description]);
    
}
-(IBAction) removeCAPKFile:(id)sender{
    int rt = [[IDT_BTPay sharedController] emv_removeCAPK:@"a000000003" index:@"01"];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"removeCAPKFile: OK."];
    }else
    {
        [self displayUpRet2: @"removeCAPKFile" returnValue:rt];
    }
}
-(IBAction) getCAPKList:(id)sender{
    NSArray* dict;
   int rt= [[IDT_BTPay sharedController] emv_retrieveCAPKList:&dict];
    if (dict == nil) {
        [self appendMessageToResults:@"CAPK List Not Returned - Try Again"];
    }
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getCAPKList: OK."];
    }else
    {
        [self displayUpRet2: @"getCAPKList" returnValue:rt];
        return;
    }
    NSLog(@"array = %@",dict.description);
}


-(IBAction) createCRLFile:(id)sender{
    CRLEntry c;
    c.rid[0] = 0xa0;
    c.rid[1] = 0x00;
    c.rid[2] = 0x00;
    c.rid[3] = 0x00;
    c.rid[4] = 0x03;
    c.index = 0x50;
    c.serialNumber[0] = 0x00;
    c.serialNumber[1] = 0x10;
    c.serialNumber[2] = 0x00;
    int rt = [[IDT_BTPay sharedController] emv_setCRL:c];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"createCRLFile: OK."];
    }else
    {
        [self displayUpRet2: @"createCRLFile" returnValue:rt];
    }
}


-(IBAction) getCRLFile:(id)sender{
    NSArray* returnArray;
    int rt = [[IDT_BTPay sharedController] emv_retrieveCRLForRID:@"a000000003" response:&returnArray];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getCRLFile: OK."];
    }else
    {
        [self displayUpRet2: @"getCRLFile" returnValue:rt];
        return;
    }
    if (returnArray == nil) {
        [self appendMessageToResults:@"CRL  File Not Returned - Try Again"];
    }
    NSLog(@"ar = %@",returnArray.description);
    [self appendMessageToResults:[NSString stringWithFormat:@"ar = %@",returnArray.description]];
 
}
-(IBAction) removeCRLFile:(id)sender{
    CRLEntry c;
    c.rid[0] = 0xa0;
    c.rid[1] = 0x00;
    c.rid[2] = 0x00;
    c.rid[3] = 0x00;
    c.rid[4] = 0x03;
    c.index = 0x50;
    c.serialNumber[0] = 0x00;
    c.serialNumber[1] = 0x10;
    c.serialNumber[2] = 0x00;
    int rt = [[IDT_BTPay sharedController] emv_removeCRLUnit:c];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"removeCRLFile: OK."];
    }else
    {
        [self displayUpRet2: @"removeCRLFile" returnValue:rt];
    }
    
}

-(IBAction) getCRLList:(id)sender{
    NSArray* dict;
    int rt = [[IDT_BTPay sharedController] emv_retrieveCRLList:&dict];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getCRLList: OK."];
    }else
    {
        [self displayUpRet2: @"getCRLList" returnValue:rt];
        return;
    }
    if (dict == nil) {
        [self appendMessageToResults:@"CRL List File Not Returned - Try Again"];
    }
    NSLog(@"array = %@",dict.description);
    [self appendMessageToResults:[NSString stringWithFormat:@"ar = %@",dict.description]];
}


-(IBAction)startEMV:(id)sender{

    NSMutableDictionary* tags;
    int rt =[[IDT_BTPay sharedController] emv_startEMVTransaction:2.95 otherAmount:0.00 timeout:30 transactionType:0 additionalTags:tags];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"startEMV: OK."];
    }else
    {
        [self displayUpRet2: @"startEMV" returnValue:rt];
    }
  
    
}

-(IBAction)completeEMV:(id)sender{
    
    
    NSMutableDictionary* dict = [NSMutableDictionary new];
    //[dict setObject:[self hexToData:@"11223344556677883030"] forKey:@"91"];
    [dict setObject:[self hexToData:@"3030"] forKey:@"8A"];
    //[dict setObject:[self hexToData:@"11223344556677883030"] forKey:@"91"];

    IDTEMVData* emvData;
    int rc = [[IDT_BTPay sharedController] emv_completeOnlineEMVTransaction:EMV_AUTHORIZATION_RESULT_ACCEPTED hostResponseTags:dict responseTags:&emvData];
    if(RETURN_CODE_DO_SUCCESS == rc)
    {
        [self appendMessageToResults:@"completeEMV: OK."];
        NSLog(@"Unencrypted Tags = %@",emvData.unencryptedTags.description);
        NSLog(@"Encrypted Tags = %@",emvData.encryptedTags.description);
        NSLog(@"Masked Tags = %@",emvData.maskedTags.description);
        NSLog(@"Result code = %2X,",emvData.resultCode);
        NSLog(@"Card Type = %@",(emvData.cardType==0)?@"Contact":@"Contactless");
        NSLog(@"Encryption Type = %@",(emvData.encryptionMode==0)?@"TDES":@"AES");
        
        [self appendMessageToResults:[NSString stringWithFormat:@"Unencrypted Tags = %@",emvData.unencryptedTags.description]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Encrypted Tags = %@",emvData.encryptedTags.description]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Masked Tags = %@",emvData.maskedTags.description]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Result code = %2X",emvData.resultCode]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Card Type = %@, Encryption Type %@",(emvData.cardType==0)?@"Contact":@"Contactless",(emvData.encryptionMode==0)?@"TDES":@"AES"]];
    }else
    {
        [self displayUpRet2: @"completeEMV" returnValue:rc];
    }

    
}

- (void) emvTransactionData:(IDTEMVData*)emvData errorCode:(int)error{
    NSLog(@"Unencrypted Tags = %@",emvData.unencryptedTags.description);
    NSLog(@"Encrypted Tags = %@",emvData.encryptedTags.description);
    NSLog(@"Masked Tags = %@",emvData.maskedTags.description);
    NSLog(@"Result code = %2X, Error Code %4X",emvData.resultCode,error);
    NSLog(@"Card Type = %@",(emvData.cardType==0)?@"Contact":@"Contactless");
    NSLog(@"Encryption Type = %@",(emvData.encryptionMode==0)?@"TDES":@"AES");
    
    [self appendMessageToResults:[NSString stringWithFormat:@"Unencrypted Tags = %@",emvData.unencryptedTags.description]];
    [self appendMessageToResults:[NSString stringWithFormat:@"Encrypted Tags = %@",emvData.encryptedTags.description]];
    [self appendMessageToResults:[NSString stringWithFormat:@"Masked Tags = %@",emvData.maskedTags.description]];
    [self appendMessageToResults:[NSString stringWithFormat:@"Result code = %2X, Error Code %4X",emvData.resultCode,error]];
    [self appendMessageToResults:[NSString stringWithFormat:@"Card Type = %@, Encryption Type %@",(emvData.cardType==0)?@"Contact":@"Contactless",(emvData.encryptionMode==0)?@"TDES":@"AES"]];
}

-(unsigned int) char2hex:(char)c{
	
	switch (c) {
		case '0' ... '9': return c - '0';
		case 'a' ... 'f': return c - 'a' + 10;
		case 'A' ... 'F': return c - 'A' + 10;
		default: return -1;
	}
}

- (NSData *)hexToData:(NSString*)str {   //Example - Pass string that contains characters "30313233", and it will return a data object containing ascii characters "0123"
	if ([str length] == 0) {
		return nil;
	}
	
	unsigned stringIndex=0, resultIndex=0, max=(int)[str length];
	NSMutableData* result = [NSMutableData dataWithLength:(max + 1)/2];
	unsigned char* bytes = [result mutableBytes];
	
	unsigned num_nibbles = 0;
	unsigned char byte_value = 0;
	
	for (stringIndex = 0; stringIndex < max; stringIndex++) {
		unsigned int val = [self char2hex:[str characterAtIndex:stringIndex]];
		
		num_nibbles++;
		byte_value = byte_value * 16 + (unsigned char)val;
		if (! (num_nibbles % 2)) {
			bytes[resultIndex++] = byte_value;
			byte_value = 0;
		}
	}
	
	
	//final nibble
	if (num_nibbles % 2) {
		bytes[resultIndex++] = byte_value;
	}
	
	[result setLength:resultIndex];
	
	return result;
}

-(IBAction) getMaskSettings:(id)sender{
    MaskAndEncryption* maskEnc;
    int rt = [[IDT_BTPay sharedController] device_getMaskAndEncryption:&maskEnc];
    
    
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"getMaskSettings: OK."];
        NSLog(@"PrePan Value = %c",maskEnc->prePANClear);
        NSLog(@"PostPan Value = %c",maskEnc->postPANClear);
        NSLog(@"Mask Char = %c",maskEnc->maskChar);
        NSLog(@"Encrypt Date = %c",maskEnc->displayExpDate);
        NSLog(@"Base Key = %c",maskEnc->baseKeyType);
        NSLog(@"Encrypte Key = %c",maskEnc->encryptionType);
        
        [self appendMessageToResults:[NSString stringWithFormat:@"PrePan Value = %c",maskEnc->prePANClear]];
        [self appendMessageToResults:[NSString stringWithFormat:@"PostPan Value = %c",maskEnc->postPANClear]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Mask Char = %c",maskEnc->maskChar]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Encrypt Date = %c",maskEnc->displayExpDate]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Base Key = %c",maskEnc->baseKeyType]];
        [self appendMessageToResults:[NSString stringWithFormat:@"Encrypte Key = %c",maskEnc->encryptionType]];
    }else
    {
        [self displayUpRet2: @"getMaskSettings" returnValue:rt];
    }
    
}
-(IBAction) setMaskDefault:(id)sender{
    int rt =[[IDT_BTPay sharedController] device_restoreMaskAndEncryptionDefaults];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"setMaskDefault: OK."];
    }else
    {
        [self displayUpRet2: @"setMaskDefault" returnValue:rt];
    }

}
-(IBAction) setBaseKey:(id)sender{
    int rt =[[IDT_BTPay sharedController] msr_setEncryptMSRFormat:1];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"setBaseKey: OK."];
    }else
    {
        [self displayUpRet2: @"setBaseKey" returnValue:rt];
    }
}
-(IBAction) setPrePAN:(id)sender{
    int rt =[[IDT_BTPay sharedController] device_setPrePANClearDigits:3];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"setPrePAN: OK."];
    }else
    {
        [self displayUpRet2: @"setPrePAN" returnValue:rt];
    }
}
-(IBAction) setPostPan:(id)sender{
    int rt =[[IDT_BTPay sharedController] device_setPostPANClearDigits:2];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"setPostPan: OK."];
    }else
    {
        [self displayUpRet2: @"setPostPan" returnValue:rt];
    }
}
-(IBAction) setMaskChar:(id)sender{
    int rt =[[IDT_BTPay sharedController] device_setPANMaskingCharacter:'#'];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"setMaskChar: OK."];
    }else
    {
        [self displayUpRet2: @"setMaskChar" returnValue:rt];
    }
}
-(IBAction) encryptDate:(id)sender{
    int rt =[[IDT_BTPay sharedController] device_setExpMasking:true];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"encryptDate: OK."];
    }else
    {
        [self displayUpRet2: @"encryptDate" returnValue:rt];
    }
    
}
-(IBAction) setEncKey:(id)sender{
    int rt =[[IDT_BTPay sharedController] msr_setCardDataEncryptedAlgorithm:2];
    if(RETURN_CODE_DO_SUCCESS == rt)
    {
        [self appendMessageToResults:@"setEncKey: OK."];
    }else
    {
        [self displayUpRet2: @"setEncKey" returnValue:rt];
    }
}

@end
